<p align="center">
  <a href="https://github.com/nonce9/pwch">
    <img alt="pwch" src="logo.svg" width="400"/>
  </a>
</p>
<p align="center">
  <a href="https://github.com/nonce9/pwch/actions/workflows/build.yml" title="Build Status">
    <img src="https://github.com/nonce9/pwch/actions/workflows/build.yml/badge.svg" alt="status-badge" />
  </a>
  <a href="https://github.com/nonce9/pwch/actions/workflows/sast.yml" title="SAST Status">
    <img src="https://github.com/nonce9/pwch/actions/workflows/sast.yml/badge.svg" alt="status-badge" />
  </a>
</p>
<p align="center">
  <a href="https://build.opensuse.org/package/show/home:nonce9/pwch" title="OBS build status">
    <img src="https://build.opensuse.org/projects/home:nonce9/packages/pwch/badge.svg?type=default" alt="status-badge">
  </a>
  <a href="https://github.com/nonce9/pwch/releases" title="Latest Release">
    <img src="https://img.shields.io/github/v/release/nonce9/pwch?style=flat&color=blue&display_name=tag&sort=semver" alt="status-badge" />
  </a>
  <img src="https://img.shields.io/badge/coverage-84%25-orange" alt="status-badge" />
  <a href="https://goreportcard.com/report/github.com/nonce9/pwch" title="Go Report">
    <img src="https://goreportcard.com/badge/github.com/nonce9/pwch" alt="status-badge" />
  </a>
</p>

<br>

# pwch (/piːwɪtʃ/)

pwch, short for password change and pronounced /piːwɪtʃ/, is a simple Go service for small mail server setups with a PostgreSQL user store and dovecot IMAP server. It enables users to change their password on their own via a pure HTML selfservice portal and encrypt dovecot mailboxes with per user keys by using Dovecot's mail-crypt-plugin. It's suppposed to be run on the same host as your dovecot IMAP server installation.

<br>

## 📦 What is needed to use it?

* a recent Debian or Ubuntu installation with
  * local dovecot
  * local reverse proxy (e.g. nginx)
* PostgreSQL database with pgcrypto extension enabled (contains user store)
* SMTP server with STARTTLS enabled

> [!IMPORTANT]
> For any further information on pwch and on how to install it, please see the [documentation](https://pwch.nonce.at).

<br>

## 🧪 Testing

Due to the external dependencies unit tests must be executed in a prepared environment.
I decided against mocking the dependencies as this would mean pulling in several
additional Go dependencies and writing a whole bunch of additional test code.

Instead I wrote an arguably huge all-in-one container image that is meant to be
used to run unit tests. However, this container functions as continuous integration test
as well. 

Here's how to run tests:

1. Build the container image
    ```
    cd test
    docker build -t pwch .
    ```

2. Run the Makefile's test target
    ```
    make test
    ```

> [!NOTE]
> Substitue `podman` with `docker` in the Makefile if using docker.

<br>

## ⚖ License

This repository is licensed under the AGPL-3.0
